/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables.records;


import com.flamesgroup.antrax.storage.commons.impl.CallAllocationAlgorithm;
import com.flamesgroup.antrax.storage.commons.impl.SmsAllocationAlgorithm;
import com.flamesgroup.storage.jooq.tables.RouteConfig;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record3;
import org.jooq.Row3;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class RouteConfigRecord extends UpdatableRecordImpl<RouteConfigRecord> implements Record3<Long, CallAllocationAlgorithm, SmsAllocationAlgorithm> {

	private static final long serialVersionUID = 891035715;

	/**
	 * Setter for <code>public.route_config.id</code>.
	 */
	public RouteConfigRecord setId(Long value) {
		setValue(0, value);
		return this;
	}

	/**
	 * Getter for <code>public.route_config.id</code>.
	 */
	public Long getId() {
		return (Long) getValue(0);
	}

	/**
	 * Setter for <code>public.route_config.call_allocation_algorithm</code>.
	 */
	public RouteConfigRecord setCallAllocationAlgorithm(CallAllocationAlgorithm value) {
		setValue(1, value);
		return this;
	}

	/**
	 * Getter for <code>public.route_config.call_allocation_algorithm</code>.
	 */
	public CallAllocationAlgorithm getCallAllocationAlgorithm() {
		return (CallAllocationAlgorithm) getValue(1);
	}

	/**
	 * Setter for <code>public.route_config.sms_allocation_algorithm</code>.
	 */
	public RouteConfigRecord setSmsAllocationAlgorithm(SmsAllocationAlgorithm value) {
		setValue(2, value);
		return this;
	}

	/**
	 * Getter for <code>public.route_config.sms_allocation_algorithm</code>.
	 */
	public SmsAllocationAlgorithm getSmsAllocationAlgorithm() {
		return (SmsAllocationAlgorithm) getValue(2);
	}

	// -------------------------------------------------------------------------
	// Primary key information
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Record1<Long> key() {
		return (Record1) super.key();
	}

	// -------------------------------------------------------------------------
	// Record3 type implementation
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row3<Long, CallAllocationAlgorithm, SmsAllocationAlgorithm> fieldsRow() {
		return (Row3) super.fieldsRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row3<Long, CallAllocationAlgorithm, SmsAllocationAlgorithm> valuesRow() {
		return (Row3) super.valuesRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field1() {
		return RouteConfig.ROUTE_CONFIG.ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<CallAllocationAlgorithm> field2() {
		return RouteConfig.ROUTE_CONFIG.CALL_ALLOCATION_ALGORITHM;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<SmsAllocationAlgorithm> field3() {
		return RouteConfig.ROUTE_CONFIG.SMS_ALLOCATION_ALGORITHM;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value1() {
		return getId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CallAllocationAlgorithm value2() {
		return getCallAllocationAlgorithm();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SmsAllocationAlgorithm value3() {
		return getSmsAllocationAlgorithm();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public RouteConfigRecord value1(Long value) {
		setId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public RouteConfigRecord value2(CallAllocationAlgorithm value) {
		setCallAllocationAlgorithm(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public RouteConfigRecord value3(SmsAllocationAlgorithm value) {
		setSmsAllocationAlgorithm(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public RouteConfigRecord values(Long value1, CallAllocationAlgorithm value2, SmsAllocationAlgorithm value3) {
		value1(value1);
		value2(value2);
		value3(value3);
		return this;
	}

	// -------------------------------------------------------------------------
	// Constructors
	// -------------------------------------------------------------------------

	/**
	 * Create a detached RouteConfigRecord
	 */
	public RouteConfigRecord() {
		super(RouteConfig.ROUTE_CONFIG);
	}

	/**
	 * Create a detached, initialised RouteConfigRecord
	 */
	public RouteConfigRecord(Long id, CallAllocationAlgorithm callAllocationAlgorithm, SmsAllocationAlgorithm smsAllocationAlgorithm) {
		super(RouteConfig.ROUTE_CONFIG);

		setValue(0, id);
		setValue(1, callAllocationAlgorithm);
		setValue(2, smsAllocationAlgorithm);
	}
}
